/*
* Copyright (c) 2007, Jing Wang
* Copyright (c) 2007, Jie Liang
* Copyright (c) 2007, Multimedia Communication Laboratory, Simon Fraser University, Canada
* All rights reserved.
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions
* are met:
* 1. Redistributions of source code must retain the above copyright
*    notice, this list of conditions and the following disclaimer.
* 2. Redistributions in binary form must reproduce the above copyright
*    notice, this list of conditions and the following disclaimer in the
*    documentation and/or other materials provided with the distribution.
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS `AS IS'
* AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
* IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
* ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
* LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
* CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
* SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
* INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
* ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
* POSSIBILITY OF SUCH DAMAGE.
*/

#ifndef __MDC_H
#define __MDC_H

#define NON_MDC    0
#define MDC_INTRA  1
#define MDC_ERROR  2

#define ALTER_SPLIT  1
#define ALTER_SLICE  64    // 0: tree spliting, n: fixed slice width = n

void mdc_split_sb(int * src, int * dst, int rw, int rh, int w, int h, int opt, int slice_w, int alter, int sb_idx);
void mdc_reset_sb(int * src, int * dst, int rw, int rh, int w, int h, int opt, int slice_w, int alter);
void mdc_prediction_sb(int * src, int * dst, int rw, int rh, int w, int h, int opt, int slice_w, int lv, int sb_idx);
void mdc_recon_sb(int * src, int * dst, int rw, int rh, int w, int h, int opt, int slice_w, int des_idx);
void mdc_combine_sb(int *src1, int *src2, int *dst, int rw, int rh, int w, int h, int opt, int slice_w, int alter, int sb_idx);
void mdc_split_tile(opj_tcd_tilecomp_t * tilec, int *src, int *dst);
void mdc_reset_tile(opj_tcd_tilecomp_t * tilec, int *src, int *dst);
void mdc_prediction_tile(opj_tcd_tilecomp_t * tilec, int *src, int *dst, int *org);
void mdc_recon_tile(opj_tcd_tilecomp_t * tilec, int *src, int *dst, int des_idx);
void mdc_combine_tile(opj_tcd_tilecomp_t * tilec, int *src1, int *src2, int *dst);
void mdc_side_decoder(opj_tcd_tilecomp_t * tilec, int des_idx);
void mdc_central_decoder(opj_tcd_tilecomp_t * tilec);

#endif
